freeslot(
    "TOL_HEDGEHOGHAMMER",
	"SPR_SDLL",
	"SPR_SUPD",
	"MT_SONICDOLL",
	"MT_SUPERDOLL",
	"S_SONICDOLL_OUT",
	"S_SONICDOLL_IN",
	"S_SUPERDOLL_OUT",
	"S_SUPERDOLL_IN"
)

G_AddGametype({
    name = "Hedgehog Hammer",
    identifier = "hedgehoghammer",
    typeoflevel = TOL_HEDGEHOGHAMMER,
	rules = GTR_FRIENDLY|GTR_SPAWNENEMIES|GTR_TIMELIMIT,
	rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 1,
    headerleftcolor = 203,
    headerrightcolor = 203,
    description = "You have one minute to whack the dolls and get points, get more points than other players!"
})

mobjinfo[MT_SONICDOLL] = {
	doomednum = 514,
	spawnhealth = 1,
	spawnstate = S_SONICDOLL_IN,
	radius = 14*FRACUNIT,
	height = 14*FRACUNIT,
	flags = MF_ENEMY|MF_SHOOTABLE,
	deathsound = sfx_pop,
	deathstate = S_XPLD1
}

mobjinfo[MT_SUPERDOLL] = {
	doomednum = 515,
	spawnhealth = 1,
	spawnstate = S_SUPERDOLL_IN,
	radius = 14*FRACUNIT,
	height = 14*FRACUNIT,
	flags = MF_ENEMY|MF_SHOOTABLE,
	deathsound = sfx_pop,
	deathstate = S_XPLD1
}

states[S_SONICDOLL_OUT] = {SPR_SDLL, 0, 80, A_ZThrust, -99, -99, S_SONICDOLL_IN}
states[S_SONICDOLL_IN] = {SPR_NULL, 0, 160, A_ZThrust, 200, 200, S_SONICDOLL_OUT}

states[S_SUPERDOLL_OUT] = {SPR_SUPD, 0, 120, A_ZThrust, -99, -99, S_SUPERDOLL_IN}
states[S_SUPERDOLL_IN] = {SPR_NULL, 0, 140, A_ZThrust, 200, 200, S_SUPERDOLL_OUT}

/*addHook("MobjThinker", function(mobj)
	local player = mobj.player
    if gametype == GT_HEDGEHOGHAMMER
		
	    TO BE FILLED IN
	end
end, MT_PLAYER)*/

addHook("MobjThinker", function(sonicdoll)
    sonicdoll.color = SKINCOLOR_BLUE
	if (sonicdoll.state == S_SONICDOLL_OUT)
	    sonicdoll.flags = $1|MF_ENEMY|MF_SHOOTABLE
	else
	    sonicdoll.flags = $1|MF_NOCLIP
	end
	if (sonicdoll.state == S_XPLD1)
	and not sonicdoll.spawnedclone == 1
		sonicdoll.spawnclone = 1
		sonicdoll.spawnedclone = 1
	end
	if (sonicdoll.spawnclone == 1)
	    sonicdoll.spawnclone = 0
		sonicdoll.spawnedclone = 0
		local doll = P_SpawnMobj(sonicdoll.x, sonicdoll.y, sonicdoll.z, MT_SUPERDOLL)
		doll.state = S_SUPERDOLL_IN
	end
end, MT_SONICDOLL)

addHook("MobjThinker", function(superdoll)
    superdoll.color = SKINCOLOR_YELLOW
	if (superdoll.state == S_SUPERDOLL_OUT)
	    superdoll.flags = $1|MF_ENEMY|MF_SHOOTABLE
	else
	    superdoll.flags = $1|MF_NOCLIP
	end
	if (superdoll.state == S_XPLD1)
	and not superdoll.spawnedclone == 1
		superdoll.spawnclone = 1
		superdoll.spawnedclone = 1
	end
	if (superdoll.spawnclone == 1)
	    superdoll.spawnclone = 0
		superdoll.spawnedclone = 0
		local doll = P_SpawnMobj(SUPERDOLL.x, SUPERDOLL.y, SUPERDOLL.z, MT_SONICDOLL)
		doll.state = S_SUPERDOLL_IN
	end
end, MT_SUPERDOLL)