freeslot(
    'SPR_PFWR',
	'SPR_LFWR',
	'MT_ROSETYPHOON_base',
	'MT_ROSETYPHOON',
	'MT_ROSESWIRL',
	'MT_FLOWERSPREAD',
	'MT_LEAFSPREAD',
	'S_FHRT1',
	'S_FHRT2',
	'S_FHRT3',
	'S_FHRT4',
	'S_FLOWERSPREAD',
	'S_FHRTALT'
)

mobjinfo[MT_ROSETYPHOON_BASE] = {
	spawnstate = 1,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = FRACUNIT,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	mass = 0,
	damage = 0,
	flags = MF_NOGRAVITY|MF_BOUNCE|MF_NOSECTOR
}


mobjinfo[MT_ROSETYPHOON] = {
	spawnstate = 1,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = FRACUNIT,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	mass = 0,
	damage = 0,
	flags = MF_NOGRAVITY|MF_SPECIAL|MF_NOSECTOR|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
}

mobjinfo[MT_ROSESWIRL] = {
	spawnstate = 1,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = FRACUNIT,
	radius = 24*FRACUNIT,
	height = 48*FRACUNIT,
	mass = 0,
	damage = 0,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_SCENERY
}

mobjinfo[MT_FLOWERSPREAD] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_FLOWERSPREAD,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}

mobjinfo[MT_LEAFSPREAD] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_FHRT1,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP
}

states[S_FHRT1] = {SPR_LFWR, 0, 2, nil, 0, 0, S_FHRT2}
states[S_FHRT2] = {SPR_LFWR, 1, 2, nil, 0, 0, S_FHRT3}
states[S_FHRT3] = {SPR_LFWR, 2, 2, nil, 0, 0, S_FHRT4}
states[S_FHRT4] = {SPR_LFWR, 3, 2, nil, 0, 0, S_FHRT1}
states[S_FHRTALT] = {SPR_PFWR, 0, -1, nil, 0, 0, S_FHRTALT}

states[S_FLOWERSPREAD] = {SPR_PFWR, 0, -1, nil, 0, 0, S_FLOWERSPREAD}

rawset(_G,"Piko_Battle",{})

local B = CBW_Battle

local cooldown = TICRATE*5
local swirl1 = S_FHRT1
local swirl2 = S_FHRTALT
local tornado_speed = FRACUNIT*10

local SetSkinVars = do
	CBW_Battle.SkinVars["modernamy"] = {
		weight = 100,
		shields = 1, 
		special = Piko_Battle.Special,
		guard_frame = 1,
		sprites = {}
	}
end

Piko_Battle.Special = function(mo,doaction)
	local player = mo.player
	if P_PlayerInPain(player) then
		player.actionstate = 0
	end
	//Action Info
	if P_IsObjectOnGround(mo) and not(player.dustdevil and player.dustdevil.valid)
		player.actiontext = "Rose Typhoon"
	else
		player.actiontext = "Rose Jump"
	end
	player.actionrings = 20
	//Neutral
	if player.actionstate == 0
		//Trigger
		if (doaction == 1) then
		    if not(P_IsObjectOnGround(mo)) //Air
				CBW_Battle.PayRings(player)
				CBW_Battle.ApplyCooldown(player,TICRATE)
				player.pflags = $|PF_THOKKED
				player.mo.state = S_PLAY_TWIN1
				P_SetObjectMomZ(mo,FixedMul(player.jumpfactor,FRACUNIT*17/CBW_Battle.WaterFactor(mo)),0)
				player.actiontime = 0
				S_StartSound(mo,sfx_s3ka0)
				local fa
				local fa2
				local ns
				local x
				local y
				local flower
				local leaf
				for i = 0, 16, 1 do
					fa = i*ANGLE_22h
					fa2 = i*ANGLE_45
					ns = 20*FRACUNIT
					x = mo.x + FixedMul(FixedMul(sin(fa),ns), mo.scale)
				    y = mo.y + FixedMul(FixedMul(cos(fa),ns), mo.scale)
					flower = P_SpawnMobj(x, y, mo.z, MT_FLOWERSPREAD)
					flower.target = mo
					flower.fuse = TICRATE/2
					flower.scale = mo.scale
					flower.flags2 = $1|MF2_DEBRIS
					flower.momx = FixedMul(FixedMul(sin(fa),ns), flower.scale)
					flower.momy = FixedMul(FixedMul(cos(fa),ns), flower.scale)
					leaf = P_SpawnMobj(x, y, mo.z, MT_LEAFSPREAD)
					leaf.target = mo
					leaf.fuse = TICRATE/2
					leaf.scale = mo.scale
					leaf.flags2 = $1|MF2_DEBRIS
					leaf.momx = FixedMul(FixedMul(sin(fa2),ns), leaf.scale)
					leaf.momy = FixedMul(FixedMul(cos(fa2),ns), leaf.scale)
				end
			else //Ground
				CBW_Battle.PayRings(player)
				CBW_Battle.ApplyCooldown(player,cooldown)
				player.actiontime = 0
			    local missile = P_SPMAngle(mo,MT_ROSETYPHOON_BASE,mo.angle)
			    if missile and missile.valid then
				    missile.color = player.skincolor
				    if not(player.mo.flags2&MF2_TWOD or twodlevel) then
					    missile.fuse = TICRATE*5
				    else
				    	missile.fuse = 45
				    end
				    S_StartSound(missile,sfx_s3kb8)
				    S_StartSound(missile,sfx_s3kcfl)	

				    if G_GametypeHasTeams() then
				    	missile.color = mo.color
						missile.colorized = true
				    end
				    if missile.tracer and missile.tracer.valid then
				    	missile.tracer.target = player.mo
				    	if P_MobjFlip(mo) == -1 then 
					    	missile.tracer.z = $-missile.tracer.height
					    	missile.tracer.flags2 = $|MF2_OBJECTFLIP
					    	missile.tracer.eflags = $|MFE_VERTICALFLIP
					    end					
						player.dustdevil = missile
					end
			    end
			end
		end
	end
end

local RoseThinker = function(mo)
	local owner = mo.target
	local hurtbox = mo.tracer
	if not(owner and owner.valid and hurtbox and hurtbox.valid) then 
		P_RemoveMobj(mo)
	return end
	
	mo.angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
-- 	local p = CBW_Battle.GetNearestPlayer(owner,nil,-1,nil,false)
-- 	if p then
-- 		mo.angle = R_PointToAngle2(mo.x,mo.y,p.mo.x,p.mo.y)
-- 	end
	local speed = FixedMul(tornado_speed,mo.scale)/CBW_Battle.WaterFactor(mo)
	if twodlevel or mo.flags2&MF2_TWOD then
		speed = $/2
	end
	hurtbox.angle = mo.angle
	hurtbox.hurtheight = min(FRACUNIT,$+FRACUNIT/35)
	P_Thrust(mo,mo.angle,speed)
	CBW_Battle.ControlThrust(mo,FRACUNIT,speed)
	if P_MobjFlip(mo) == 1 then
		P_TeleportMove(hurtbox,mo.x,mo.y,mo.z)
	else
		P_TeleportMove(hurtbox,mo.x,mo.y,mo.z+mo.height-hurtbox.height)
	end
	hurtbox.fuse = mo.fuse
	if not(leveltime&3) then
		for n = 1, 4
			local swirl = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ROSESWIRL)
			if swirl and swirl.valid then
				swirl.target = hurtbox
				swirl.angle = mo.angle+ANGLE_90*n
				if P_MobjFlip(mo) == -1 then 
					swirl.flags2 = $|MF2_OBJECTFLIP
					swirl.eflags = $|MFE_VERTICALFLIP
				end
				if n&1 then
					swirl.swirltype = 1
					swirl.state = swirl1
-- 					swirl.rotatespeed = $*2
				else
					swirl.state = swirl2
	-- 				swirl.flags2 = MF2_SHADOW
				end
				if n&2
					swirl.reach = 32*mo.scale
				end

-- 				swirl.reach = P_RandomRange(32,64)*mo.scale
-- 				swirl.rotatespeed = P_RandomRange(10,30)*ANG1
			end
		end
	end
end

local RoseSwirlSpawn = function(mo)
-- 	mo.rotatespeed = ANG15
	mo.rotatespeed = ANG30
-- 	mo.fusetime = TICRATE*2
	mo.fusetime = TICRATE
	mo.scale = $*3/4
	mo.fuse = mo.fusetime
	mo.reach = 0
	mo.swirltype = 0
end

local RoseSwirlThinker = function(mo)
	if not(mo and mo.valid and mo.target and mo.target.valid) then 
		P_RemoveMobj(mo)
	return end
	
	//Blink
	if mo.target.fuse < TICRATE then
		mo.flags2 = $^^MF2_DONTDRAW
	end
	//Regulate State
	if mo.swirltype == 0 then
		mo.state = swirl2
	else
		mo.state = swirl1
	end
	//Do swirl
	mo.angle = $+mo.rotatespeed
	local time = FRACUNIT*(mo.fusetime-mo.fuse)/mo.fusetime 
	local dist = CBW_Battle.FixedLerp(mo.target.minradius,mo.reach+mo.target.radius,time)
	local x = P_ReturnThrustX(nil,mo.angle,dist)
	local y = P_ReturnThrustY(nil,mo.angle,dist)
	local z
	if P_MobjFlip(mo) == 1 then 
		z = CBW_Battle.FixedLerp(0,mo.target.height-mo.height,time)
	else
		z = CBW_Battle.FixedLerp(mo.target.height-mo.height,0,time)	
	end
	P_TeleportMove(mo,mo.target.x+x,mo.target.y+y,mo.target.z+z)
end

local RoseSpawn = function(mo)
	mo.tracer = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ROSETYPHOON)
	if mo.tracer and mo.tracer.valid then
		mo.tracer.scale = mo.scale*4
		mo.tracer.minradius = mo.tracer.radius/4
		mo.tracer.hurtheight = 0
		if P_MobjFlip(mo) == -1 then 
			mo.tracer.flags2 = $|MF2_OBJECTFLIP
			mo.tracer.eflags = $|MFE_VERTICALFLIP
		end
	end
end

local RoseTouch = function(dustdevil,collide)
	//Failsafe
	if dustdevil.hurtheight == nil then return end
	if not(dustdevil and dustdevil.valid and dustdevil.target and dustdevil.target.valid) then 
	return true end
	
	local push = false
	if collide.battleobject then push = true end
	local player = nil
	if collide.player then player = collide.player end
	
	//Get cone-like hit dimensions
	local w1 		= dustdevil.radius-dustdevil.minradius //Width of narrow end of cone
	local w2 		= dustdevil.radius //Width of wide end of cone
	local hurtheight	= max(FRACUNIT/35,FixedMul(dustdevil.hurtheight,dustdevil.height))
	
	local z,w //Nearest Z coordinate and its corresponding radius
	if not(dustdevil.flags2&MF2_OBJECTFLIP) then //Regular orientation
		//Z checks
		if dustdevil.z > collide.z+collide.height
		or collide.z > dustdevil.z+hurtheight
		return true end
		z	= //Get nearest z point
			min(dustdevil.z+hurtheight, //Max height: tornado base + hurtbox height
			max(dustdevil.z, //Min height: tornado base
			collide.z)) //Colliding object's lower z position
		w	= CBW_Battle.FixedLerp(w1,w2,FixedDiv(z-dustdevil.z,hurtheight)) //Get the interpolated width value corresponding to the nearest z point on hurtbox
	else //Flipped orientation
		if dustdevil.z+dustdevil.height < collide.z
		or collide.z+collide.height < dustdevil.z+dustdevil.height-hurtheight
		return true end
		z	= 
			min(dustdevil.z+dustdevil.height, //Max height: tornado base + "true" height 
			max(dustdevil.z+dustdevil.height-hurtheight, //Min height: tornado base + "true" height - hurtbox height
			collide.z+collide.height)) //Colliding object's upper z position
		w	= CBW_Battle.FixedLerp(w1,w2,-FixedDiv(z-dustdevil.z-dustdevil.height,hurtheight)) //flip args 1&2 to invert interpolation
	end
	local dist = R_PointToDist2(dustdevil.x,dustdevil.y,collide.x,collide.y)
	//No collision
	if dist > w then 
-- 		print("\x85"..hurtheight*100/dustdevil.height.."%..."..w*100/dustdevil.radius.."%..."..dist/FRACUNIT)
		return true
	end
-- 	print("\x83 "..hurtheight*100/dustdevil.height.."%..."..w*100/dustdevil.radius.."%..."..dist/FRACUNIT)
	//Self collision
	if dustdevil.target == collide and player
		if collide.state >= S_PLAY_TWIN1 and collide.state <= S_PLAY_TWIN7 and not dustdevil.iscarrying then //Air-ground combo
			if not(S_SoundPlaying(collide,sfx_wdjump)) then
				S_StartSound(collide,sfx_wdjump)
			end
			P_SetObjectMomZ(collide,FRACUNIT*24/CBW_Battle.WaterFactor(collide),0)
		end
	return true end
	
	local friendly = collide.player and CBW_Battle.MyTeam(dustdevil.target,collide)
	//Enemy collision
	if not(friendly) then
-- 		local damagethrust = not(collide.player or collide.player.powers[pw_flashing]) //or CBW_Battle.PlayerCanBeDamaged(collide.player)
        P_TeleportMove(collide, dustdevil.x, dustdevil.y, dustdevil.z)
		P_InstaThrust(collide,collide.angle,FRACUNIT)
		P_SetObjectMomZ(collide, FRACUNIT, false)
		dustdevil.iscarrying = 1
		if push then
			collide.target = dustdevil.target
		end
	end
	if(friendly)
		CBW_Battle.AddPinkShield(collide.player,dustdevil.target.player)
	end
	return true
end

addHook("TouchSpecial",RoseTouch,MT_ROSETYPHOON)

addHook("MobjMoveCollide",function(mover,collide)
	if not(collide.battleobject) then return end
	RoseTouch(mover,collide)
end,MT_ROSETYPHOON)

addHook("MobjThinker",RoseThinker, MT_ROSETYPHOON_BASE)
addHook("MobjSpawn",RoseSwirlSpawn,MT_ROSESWIRL)
addHook("MobjThinker",RoseSwirlThinker, MT_ROSESWIRL)
addHook("MobjSpawn",RoseSpawn,MT_ROSETYPHOON_BASE)

local loaded = false
addHook("ThinkFrame",do
	if not(loaded) and CBW_Battle != nil
		loaded = true
		SetSkinVars()
	end
end)