freeslot(
    "SPR_RCRM",
	"MT_ROSYCHARM",
	"S_ROSYCHARM1",
	"S_ROSYCHARM2",
	"S_ROSYCHARM3",
	"S_ROSYCHARM4",
	"S_ROSYCHARM5",
	"S_ROSYCHARM6",
	"S_ROSYCHARM7",
	"S_ORBITCHARM1",
	"S_ORBITCHARM2"
)

mobjinfo[MT_ROSYCHARM] = {
    spawnstate = S_ROSYCHARM1,
	spawnhealth = 1000,
    reactiontime = 8,
    speed = 20*FRACUNIT,
    radius = 32*FRACUNIT,
    height = 64*FRACUNIT,
    mass = 16,
    damage = 0,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SPECIAL|MF_MISSILE
}

states[S_ROSYCHARM1] = {SPR_RCRM, A|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM2}
states[S_ROSYCHARM2] = {SPR_RCRM, B|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM3}
states[S_ROSYCHARM3] = {SPR_RCRM, C|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM4}
states[S_ROSYCHARM4] = {SPR_RCRM, D|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM5}
states[S_ROSYCHARM5] = {SPR_RCRM, E|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM6}
states[S_ROSYCHARM6] = {SPR_RCRM, F|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM7}
states[S_ROSYCHARM7] = {SPR_RCRM, G|FF_FULLBRIGHT, 1, nil, 0, 0, S_ROSYCHARM1}

states[S_ORBITCHARM1] = {SPR_RCRM, A|FF_FULLBRIGHT, 1, A_Custom3DRotate, 50+10<<16, 100<<16, S_ORBITCHARM2}
states[S_ORBITCHARM2] = {SPR_RCRM, D|FF_FULLBRIGHT, 1, A_Custom3DRotate, 50+10<<16, 100<<16, S_ORBITCHARM1}

rawset(_G,"Rascal_Battle",{})

local B = CBW_Battle

local ground_special = 1
local air_special = 10
local cooldown = TICRATE
local swirl1 = S_HEART
local swirl2 = S_HEART
local tornado_speed = FRACUNIT*10

local SetSkinVars = do
	CBW_Battle.SkinVars["rosy"] = {
		weight = 100,
		shields = 1, 
		special = Rascal_Battle.Special,
		guard_frame = 1,
		func_priority_ext = Rascal_Battle.Priority,
		sprites = {}
	}
end

Rascal_Battle.Priority = function(player)
	if player.actionstate == ground_special then
		CBW_Battle.SetPriority(player,2,3,nil,2,3,"rosy spin technique")
	elseif player.actionstate == air_special then
	    CBW_Battle.SetPriority(player,2,3,nil,2,3,"super slam technique")
		//CBW_Battle.SetPriority(player,2,3,nil,2,3,"charm beam")
	end
end

local function sparkle(mo)
	local heart = P_SpawnMobj(mo.x,mo.y,mo.z,MT_HEART)
	heart.fuse = TICRATE/8
	heart.target = mo
	heart.flags = MF_MISSILE|MF_SCENERY|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
	if heart and heart.valid then
		CBW_Battle.AngleTeleport(heart,{mo.x,mo.y,mo.z},mo.player.drawangle,0,mo.scale*64)
		end
end

local function spinhammer(mo)
	mo.state = S_PLAY_MELEE
	mo.frame = 3
	mo.sprite2 = SPR2_MLEE
end

Rascal_Battle.Special = function(mo,doaction)
	local player = mo.player
	if P_PlayerInPain(player) then
		player.actionstate = 0
		player.actiontime = 0
	end
	if not(CBW_Battle.CanDoAction(player)) and not(player.actionstate) 
		if player.actiontime and mo.state == S_PLAY_MELEE_FINISH
			if mo.tics == -1
				mo.tics = 15
			else
				mo.tics = min($,15)
			end
			player.actiontime = 0
		end
	return end
	player.actiontime = $+1
	//Action Info
	if P_IsObjectOnGround(mo) and not(player.dustdevil and player.dustdevil.valid)
		player.actiontext = "Rosy Tornado"
	elseif P_IsObjectOnGround(mo) and (player.dustdevil and player.dustdevil.valid)
	    player.actiontext = "Rosy Spin"
	elseif not P_IsObjectOnGround(mo)
	    player.actiontext = "Super Slam"
		//player.actiontext = "Charm Beam"
	end
	player.actionrings = 10
	//Neutral
	if player.actionstate == 0
		//Trigger
		if (doaction == 1) then
			if not(P_IsObjectOnGround(mo)) //Air
				CBW_Battle.PayRings(player)
				mo.state = S_PLAY_HAMMERDOWN1
				player.mo.slam = 1
				/*local charm = P_SPMAngle(mo, MT_ROSYCHARM, mo.angle)
		        if charm and charm.valid then
			        S_StartSound(charm,sfx_s3kb8)
					player.actiontime = 0
			        charm.scale = $/2
					charm.target = mo
			        charm.destscale = $*4
			        charm.scalespeed = $/2
			        if G_GametypeHasTeams() then
			            charm.color = mo.color
			        end
				end*/
			else //Ground
				CBW_Battle.PayRings(player)
				player.actionstate = ground_special
				CBW_Battle.ControlThrust(mo,mo.scale/4)
				player.actiontime = 0
				S_StartSound(mo,sfx_s3ka0)
			end
		end
	end
	//Air Tweaks
	if (player.mo.slam == 1)
	and P_IsObjectOnGround(mo)
	    player.mo.slam = 0
		player.mo.slam2 = 1
		A_ZThrust(mo, 15, 0)
		player.mo.state = S_PLAY_TWIRL1
		S_StartSound(mo, sfx_s3kae)
	end
	if (player.mo.slam2 == 1)
	and player.mo.state == S_PLAY_TWIRL12
	    player.mo.state = S_PLAY_TWIRL1
	end
	if (player.mo.slam2 == 1)
	and P_IsObjectOnGround(mo)
	    player.mo.state = S_PLAY_HAMMER6
		A_ZThrust(mo, 20, 0)
		player.mo.slam2 = 0
		S_StartSound(mo, sfx_s3k98)
		for i = 0, 16, 1 do
		local heart = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HEART)
			heart.momx = P_RandomRange(-24, 24)*FRACUNIT
			heart.momy = P_RandomRange(-24, 24)*FRACUNIT
			heart.momz = P_RandomRange(2, 24)*FRACUNIT
			heart.fuse = TICRATE
			heart.target = mo
			local fake = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HEARTATTACK)
			fake.momx = P_RandomRange(-24, 24)*FRACUNIT
			fake.momy = P_RandomRange(-24, 24)*FRACUNIT
			fake.momz = P_RandomRange(2, 24)*FRACUNIT
			fake.fuse = TICRATE
			fake.target = mo
		end
	end
    if (player.mo.slam == 1)
	and (player.mo.state == S_PLAY_HAMMERDOWN5) or (player.mo.state == S_PLAY_HAMMERDOWN6)
	and (player.mo.momz > (9000*P_MobjFlip(player.mo)))
		P_SetObjectMomZ(player.mo, FixedMul(-30*FRACUNIT, player.mo.scale))
	end
	if not (player.mo.state >= S_PLAY_HAMMERDOWN1) and (player.mo.state <= S_PLAY_HAMMERDOWN6)
	and (player.mo.slam == 1)
	    player.mo.slam = 0
	end
	if not (player.mo.state >= S_PLAY_TWIRL1) and (player.mo.state <= S_PLAY_TWIRL12)
	and (player.mo.slam2 == 1)
	    player.mo.slam2 = 0
	end
	//Ground Special
	if player.actionstate == ground_special then
		spinhammer(mo)

		player.powers[pw_nocontrol] = max($,2)
		sparkle(mo)
		if player.actiontime < 16 then
			player.drawangle = mo.angle+ANGLE_22h*player.actiontime
			P_Thrust(mo,mo.angle,mo.scale)
			if player.actiontime == 8 then
				S_StartSound(mo,sfx_s3k42)
			end
		else
			player.drawangle = mo.angle+ANGLE_45*(player.actiontime&7)
			P_Thrust(mo,mo.angle,mo.scale)
			if player.actiontime&7 == 4 then
				S_StartSound(mo,sfx_s3k42)
			end
		end
		if not(player.actiontime > TICRATE) then return end
		player.actionstate = $+1
		player.actiontime = 0
		player.drawangle = mo.angle
		//Do Missile
		if not(player.dustdevil and player.dustdevil.valid)
			local missile = P_SPMAngle(mo,MT_DUSTDEVIL_BASE,mo.angle)
			if missile and missile.valid then
				missile.color = player.skincolor
				if not(player.mo.flags2&MF2_TWOD or twodlevel) then
					missile.fuse = TICRATE*5
				else
					missile.fuse = 45
				end
				S_StartSound(missile,sfx_s3kb8)
				S_StartSound(missile,sfx_s3kcfl)	

				if G_GametypeHasTeams() then
					missile.color = mo.color
				end
-- 				if P_MobjFlip(mo) == -1 then
-- 					missile.z = $-missile.height
-- 					missile.flags2 = $|MF2_OBJECTFLIP
-- 					missile.eflags = $|MFE_VERTICALFLIP
-- 				end
				if missile.tracer and missile.tracer.valid then
					missile.tracer.target = player.mo
					if P_MobjFlip(mo) == -1 then 
						missile.tracer.z = $-missile.tracer.height
						missile.tracer.flags2 = $|MF2_OBJECTFLIP
						missile.tracer.eflags = $|MFE_VERTICALFLIP
					end					
				end
				player.dustdevil = missile
			end
		end
	end
	//End lag
	if player.actionstate == ground_special+1 
		player.powers[pw_nocontrol] = max($,2)
		if player.actiontime < TICRATE return end
		//Neutral
		CBW_Battle.ApplyCooldown(player,cooldown)
		player.actionstate = 0
		player.actiontime = 0
		mo.state = S_PLAY_WALK
	end
end

local DustDevilThinker = do
	local owner = mo.target
	local hurtbox = mo.tracer
	if not(owner and owner.valid and hurtbox and hurtbox.valid) then 
		P_RemoveMobj(mo)
	return end
	
	mo.angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
-- 	local p = CBW_Battle.GetNearestPlayer(owner,nil,-1,nil,false)
-- 	if p then
-- 		mo.angle = R_PointToAngle2(mo.x,mo.y,p.mo.x,p.mo.y)
-- 	end
	local speed = FixedMul(tornado_speed,mo.scale)/CBW_Battle.WaterFactor(mo)
	if twodlevel or mo.flags2&MF2_TWOD then
		speed = $/2
	end
	hurtbox.angle = mo.angle
	hurtbox.hurtheight = min(FRACUNIT,$+FRACUNIT/35)
	P_Thrust(mo,mo.angle,speed)
	CBW_Battle.ControlThrust(mo,FRACUNIT,speed)
	if P_MobjFlip(mo) == 1 then
		P_TeleportMove(hurtbox,mo.x,mo.y,mo.z)
	else
		P_TeleportMove(hurtbox,mo.x,mo.y,mo.z+mo.height-hurtbox.height)
	end
	hurtbox.fuse = mo.fuse
	if not(leveltime&3) then
		for n = 1, 4
			local swirl = P_SpawnMobj(mo.x,mo.y,mo.z,MT_SWIRL)
			if swirl and swirl.valid then
				swirl.target = hurtbox
				swirl.angle = mo.angle+ANGLE_90*n
				swirl.color = CBW_Battle.Choose(mo.color,SKINCOLOR_SILVER)
				if P_MobjFlip(mo) == -1 then 
					swirl.flags2 = $|MF2_OBJECTFLIP
					swirl.eflags = $|MFE_VERTICALFLIP
				end
				if n&1 then
					swirl.swirltype = 1
					swirl.state = swirl1
					swirl.scale = $/4
-- 					swirl.rotatespeed = $*2
				else
					swirl.state = swirl2
					swirl.colorized = true
	-- 				swirl.flags2 = MF2_SHADOW
				end
				if n&2
					swirl.reach = 32*mo.scale
				end

-- 				swirl.reach = P_RandomRange(32,64)*mo.scale
-- 				swirl.rotatespeed = P_RandomRange(10,30)*ANG1
			end
		end
	end
end

local SwirlSpawn = do
-- 	mo.rotatespeed = ANG15
	mo.rotatespeed = ANG30
-- 	mo.fusetime = TICRATE*2
	mo.fusetime = TICRATE
	mo.scale = $*3/4
	mo.fuse = mo.fusetime
	mo.reach = 0
	mo.swirltype = 0
end

local SwirlThinker = do
	if not(mo and mo.valid and mo.target and mo.target.valid) then 
		P_RemoveMobj(mo)
	return end
	
	//Blink
	if mo.target.fuse < TICRATE then
		mo.flags2 = $^^MF2_DONTDRAW
	end
	//Regulate State
	if mo.swirltype == 0 then
		mo.state = swirl2
	else
		mo.state = swirl1
	end
	//Do swirl
	mo.angle = $+mo.rotatespeed
	local time = FRACUNIT*(mo.fusetime-mo.fuse)/mo.fusetime 
	local dist = CBW_Battle.FixedLerp(mo.target.minradius,mo.reach+mo.target.radius,time)
	local x = P_ReturnThrustX(nil,mo.angle,dist)
	local y = P_ReturnThrustY(nil,mo.angle,dist)
	local z
	if P_MobjFlip(mo) == 1 then 
		z = CBW_Battle.FixedLerp(0,mo.target.height-mo.height,time)
	else
		z = CBW_Battle.FixedLerp(mo.target.height-mo.height,0,time)	
	end
	P_TeleportMove(mo,mo.target.x+x,mo.target.y+y,mo.target.z+z)
end

local DustDevilSpawn = do
	mo.tracer = P_SpawnMobj(mo.x,mo.y,mo.z,MT_DUSTDEVIL)
	if mo.tracer and mo.tracer.valid then
		mo.tracer.scale = mo.scale*4
		mo.tracer.minradius = mo.tracer.radius/4
		mo.tracer.hurtheight = 0
		if P_MobjFlip(mo) == -1 then 
			mo.tracer.flags2 = $|MF2_OBJECTFLIP
			mo.tracer.eflags = $|MFE_VERTICALFLIP
		end
	end
end

local DustDevilTouch = do
	//Failsafe
	if dustdevil.hurtheight == nil then return end
	if not(dustdevil and dustdevil.valid and dustdevil.target and dustdevil.target.valid) then 
	return true end
	
	local push = false
	if collide.battleobject then push = true end
	local player = nil
	if collide.player then player = collide.player end
	
	//Get cone-like hit dimensions
	local w1 		= dustdevil.radius-dustdevil.minradius //Width of narrow end of cone
	local w2 		= dustdevil.radius //Width of wide end of cone
	local hurtheight	= max(FRACUNIT/35,FixedMul(dustdevil.hurtheight,dustdevil.height))
	
	local z,w //Nearest Z coordinate and its corresponding radius
	if not(dustdevil.flags2&MF2_OBJECTFLIP) then //Regular orientation
		//Z checks
		if dustdevil.z > collide.z+collide.height
		or collide.z > dustdevil.z+hurtheight
		return true end
		z	= //Get nearest z point
			min(dustdevil.z+hurtheight, //Max height: tornado base + hurtbox height
			max(dustdevil.z, //Min height: tornado base
			collide.z)) //Colliding object's lower z position
		w	= CBW_Battle.FixedLerp(w1,w2,FixedDiv(z-dustdevil.z,hurtheight)) //Get the interpolated width value corresponding to the nearest z point on hurtbox
	else //Flipped orientation
		if dustdevil.z+dustdevil.height < collide.z
		or collide.z+collide.height < dustdevil.z+dustdevil.height-hurtheight
		return true end
		z	= 
			min(dustdevil.z+dustdevil.height, //Max height: tornado base + "true" height 
			max(dustdevil.z+dustdevil.height-hurtheight, //Min height: tornado base + "true" height - hurtbox height
			collide.z+collide.height)) //Colliding object's upper z position
		w	= CBW_Battle.FixedLerp(w1,w2,-FixedDiv(z-dustdevil.z-dustdevil.height,hurtheight)) //flip args 1&2 to invert interpolation
	end
	local dist = R_PointToDist2(dustdevil.x,dustdevil.y,collide.x,collide.y)
	//No collision
	if dist > w then 
-- 		print("\x85"..hurtheight*100/dustdevil.height.."%..."..w*100/dustdevil.radius.."%..."..dist/FRACUNIT)
		return true
	end
-- 	print("\x83 "..hurtheight*100/dustdevil.height.."%..."..w*100/dustdevil.radius.."%..."..dist/FRACUNIT)
	//Self collision
	if dustdevil.target == collide and player
		if collide.player.actionstate == air_special then //Air-ground combo
			if not(S_SoundPlaying(collide,sfx_wdjump)) then
				S_StartSound(collide,sfx_wdjump)
			end
			P_SetObjectMomZ(collide,FRACUNIT*24/CBW_Battle.WaterFactor(collide),0)
		end
	return true end
	
	local friendly = collide.player and CBW_Battle.MyTeam(dustdevil.target,collide)
	//Enemy collision
	if not(friendly) then
		local r = R_PointToAngle2(dustdevil.x,dustdevil.y,collide.x,collide.y)
-- 		local damagethrust = not(collide.player or collide.player.powers[pw_flashing]) //or CBW_Battle.PlayerCanBeDamaged(collide.player)
		P_DamageMobj(collide,dustdevil,dustdevil.target)
		if push then
			collide.target = dustdevil.target
		end
		if not(collide.player) or P_PlayerInPain(collide.player)
			P_SetObjectMomZ(collide,FRACUNIT*16/CBW_Battle.WaterFactor(collide),0)
			P_InstaThrust(collide,r,dustdevil.scale*6)
		end
	end
	if(friendly)
		CBW_Battle.AddPinkShield(collide.player,dustdevil.target.player)
	end
	return true
end

/*local DoCharmed=function(player)
    player.powers[pw_nocontrol] = 3*TICRATE
	player.cancharm = 1
    if player.powers[pw_nocontrol] and player.cancharm == 1
	    player.charmed = 1
		player.powers[pw_flashing] = 0
	    for i = 0, 8, 1 do
		    local orbit = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height, MT_ORBITHEART)
			orbit.target = player.mo
			orbit.scale = orbit.target.scale
			orbit.flags = MF_NOCLIP
			orbit.state = S_ORBITCHARM1
			orbit.charming = 1
			orbit.fuse = 3*TICRATE
			orbit.angle = i*ANGLE_45
		end
    end
	if not player.powers[pw_nocontrol] and player.cancharm == 1
	    player.charmed = 0
		player.cancharm = 0
	end
end

local CharmBeamThinker=function(mo)
	local ghost = P_SpawnGhostMobj(mo)
	local newscale = FRACUNIT / 2
	ghost.scale = mo.scale
	ghost.z = mo.z
	if P_RandomChance(FRACUNIT/8)
		P_SpawnMobj(mo.x+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.y+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.z+P_RandomRange(0,mo.height/FRACUNIT)*FRACUNIT,MT_SPARK)
    end
end

local CharmBeamCollision=function(pmo,mo,source)
	if not(mo and mo.valid and mo.type == MT_ROSYCHARM) then return end
	if not(pmo and pmo.valid and pmo.player) then return end
	if not(source and source.valid and source.player) then return end
	//Player cannot interact
	if not(CBW_Battle.PlayerCanBeDamaged(pmo.player) or CBW_Battle.MyTeam(pmo.player,source.player)) then return end
	//Same team
	if source.player and CBW_Battle.MyTeam(source.player,pmo.player) then
		mo.target = pmo
		S_StartSound(pmo,sfx_cdpcm6)
		P_AddPlayerScore(source.player,25)
		A_GiveShield(pmo, SH_PINK)
		return false
	end
	//Enemy
	S_StartSound(pmo,sfx_cdpcm6)
	P_DoPlayerPain(pmo.player,mo,source)
	P_PlayerFlagBurst(pmo.player,false)
	DoCharmed(pmo.player,TICRATE*8)
	print(source.player.ctfname.."'s charm beam stunned "..pmo.player.ctfname..".")
	if G_TagGametype() then
		P_AddPlayerScore(source.player,100)
	else
		P_AddPlayerScore(source.player,50)
	end
	return false
end

addHook("MobjThinker",function(mo) CharmBeamThinker(mo) end,MT_ROSYCHARM)
addHook("ShouldDamage",function(pmo,mo,source) return CharmBeamCollision(pmo,mo,source) end,MT_PLAYER)*/

addHook("HurtMsg",function(player,inflictor,source)
    if not CBW_Battle then return end
	if not(inflictor and inflictor.player) then return end
	if not (inflictor.player.skin == "rosy") then return end
	inflictor.player.battle_hurttxt = "hammer attack"
	local attacktext = inflictor.player.battle_hurttxt
	if attacktext then print(CBW_Battle.CustomHurtMessage(player,inflictor,attacktext)) return true end
end,MT_PLAYER)

local loaded = false
addHook("ThinkFrame",do
	if not(loaded) and CBW_Battle != nil
		loaded = true
		SetSkinVars()
	end
end)